/***************************************************************************
 *
 * CRI Middleware SDK
 *
 * Copyright (c) 2001-2004 CRI-MW
 *
 * Appli.   : ADXT Sample Program 
 * Module   : Main function.(Seamless Continuous Play)
 * File     : adxslply.c
 *
 ***************************************************************************/

/***************************************************************************
 *		インクルードファイル
 *		Include file
 ***************************************************************************/
#include <stdio.h>
#include <cri_mw.h>
#include "usr/usr.h"

/***************************************************************************
 *		定数マクロ
 *		Constant Macro
 ***************************************************************************/

/*	最大チャンネル数				*/
/*	The number of maximum channels	*/
#define	MAX_CH			(2)

/*	同時再生最大ストリーム数									*/
/*	The number of maximum disc streams playing at the same time	*/
#define	MAX_STM			(1)

/*	最高サンプリング周波数		*/
/*	Maximum sampling frequency	*/
#define	MAX_SFREQ		(48000)

/*	ADX再生用作業領域の大きさ	*/
/*	Work area size of ADX play	*/
#define	ADXT_WKSIZE		ADXT_CALC_WORK(MAX_CH, 1, MAX_STM, MAX_SFREQ)

/***************************************************************************
 *		処理マクロ
 *		Process MACRO
 ***************************************************************************/

/*	フラグON/OFFの反転		*/
/*	Turn over flag(ON/OFF)	*/
#define NOT_FLAG(flag)		(((flag) == OFF) ? ON : OFF)

#define UNUSED(x)				((x) = (x))

/***************************************************************************
 *		変数定義
 *		Variable Definition
 ***************************************************************************/

/*	アプリケーション構造体											*/
/*	Application structure											*/
typedef struct {
	Sint32	disp_flag;				//	Display information flag
	Sint32	pause;					//	Pause flag
	ADXT 	adxt;					//	ADXT Player
	Char8	*fname[2];				//	ADX File name
	Char8	adxt_work[ADXT_WKSIZE];	//	Work area for ADXT
} AP_OBJ;

/*	アプリケーションオブジェクト									*/
/*	Application Object												*/
AP_OBJ ap_obj = {
	ON,								//	Display Info.
	OFF,							//	not puase
	NULL,							//	Player
	{
		"smpsl48a.adx",				//	ADX File name 1
		"smpsl48b.adx"				//	ADX File name 2
	}, 		
};

/***************************************************************************
 *		関数宣言
 *		Function Declaration
 ***************************************************************************/
void ap_adx_err_func(void *obj, Char8 *msg);
void ApInitMw(AP_OBJ *ap);
void ApFinishMw(AP_OBJ *ap);
void ApStart(AP_OBJ *ap);
void ApStop(AP_OBJ *ap);
void ap_disp_info(AP_OBJ *ap);
Sint32 ApExec(AP_OBJ *ap);

/***************************************************************************
 *		関数定義
 *		Function Definition
 ***************************************************************************/

/***
 *			ミドルウェアの再生
 *			Playing middleware
 ***/

/*	ミドルウェアのエラー発生時に起動する関数			*/
/*	Callback function when an error occur in middleware	*/
void ap_adx_err_func(void *obj, Char8 *msg)
{
	UNUSED(obj);		// 未使用変数

	UsrDbgPrintf(msg);

	for (;;) {		/*	リリース時には無くす					*/
		;			/*	Delete when you release application.	*/
	}
}

/*	ミドルウェアの初期化				*/
/*	Initialize Middleware				*/
void ApInitMw(AP_OBJ *ap)
{
	UNUSED(ap);

	/*	ADXライブラリ初期化		*/
	/*	Initialize ADX library	*/
	ADXT_Init();
}


/*	ミドルウェアの終了					*/
/*	Finalize Middleware					*/
void ApFinishMw(AP_OBJ *ap)
{
	UNUSED(ap);
	
	ADXT_Finish();
}

/*	アプリケーション開始処理	*/
/*	Start application		*/
void ApStart(AP_OBJ *ap)
{
	ADXT adxt;
	
	adxt = ap->adxt = ADXT_Create(2, ap->adxt_work, ADXT_WKSIZE);
	ADXT_EntryFname(adxt, ap->fname[0]);
	ADXT_EntryFname(adxt, ap->fname[0]);
	ADXT_EntryFname(adxt, ap->fname[1]);
	ADXT_SetSeamlessLp(adxt, 1);			// シームレスループ再生の設定
	ADXT_StartSeamless(adxt);
}

/*	アプリケーション停止処理	*/
/*	Stop application		*/
void ApStop(AP_OBJ *ap)
{
	ADXT_Destroy(ap->adxt);
}

/*	情報の表示			*/
/*	Display infomation	*/
void ap_disp_info(AP_OBJ *ap)
{
	ADXT adxt=ap->adxt;
	char *ststr[6] =
		{"STOP   ", "DECINFO   ", "PREP   ", "PLAYING", "DECEND ", "PLAYEND"};
	Sint32 stat, sfreq, cnt;
	Sint32 hh, mm, ss, ff;

	UsrPrintf(3, 3, "ADX Sample Program");
	UsrPrintf(3, 4, "   (Seamless Continuous Play)");
	stat = ADXT_GetStat(adxt);
	UsrPrintf(5, 6, "Stat = %s", ststr[stat]);
	ADXT_GetTime(adxt, &cnt, &sfreq);
	UsrSfcnt2time(sfreq,  cnt, &hh, &mm, &ss, &ff);
	UsrPrintf(5, 7, "Time =%2d:%02d:%02d.%02d", hh, mm, ss, ff);
	UsrPrintf(5, 8, "Number of Files = %d", ADXT_GetNumFiles(adxt));
}

/*	動画の再生					*/
/*	Playing the animation file	*/
Sint32 ApExec(AP_OBJ *ap)
{
	ADXT					adxt=ap->adxt;
	Sint32					stat;
	const USR_PERIPHERAL	*per;

	per = UsrGetPeripheral(0);	
	if (per->press & UTPAD_L)
		ap->disp_flag = NOT_FLAG(ap->disp_flag);

	if (per->press & UTPAD_BUTTON1)
		return FALSE;

	if (per->press & UTPAD_START) {
		ap->pause = NOT_FLAG(ap->pause);
		ADXT_Pause(adxt, ap->pause);	/*	一時停止解除			*/
										/*	Release pause status	*/
	}
	/*	Checking status												*/
	stat = ADXT_GetStat(adxt);
	if (stat == ADXT_STAT_PLAYEND)
		return FALSE;
	if (ap->disp_flag == ON)
		ap_disp_info(ap);

	/* CRI Middleware Library's Server function */
	ADXM_ExecMain();

	return TRUE;
}

/***
 *		メイン処理
 *		MAIN
 ***/
int main(void)
{
	AP_OBJ	*ap;
	Sint32	term_flag = OFF;
	Bool	ret;

	ap = &ap_obj;

	/*	エラーコールバック関数の登録		*/
	/*	Entry ADX error callback function	*/
	ADXM_SetCbErr(ap_adx_err_func, NULL);
	
	/*	システムの初期化										*/
	/*	Initialize System										*/
	UsrInitSystem(NULL, NULL);
	
	/*	ビデオの初期化											*/
	/*	Initialize Video System									*/
	UsrInitVideo(NULL, NULL);
	
	/*	サウンドの初期化										*/
	/*	Initialize Sound System									*/
	UsrInitSound(NULL, NULL);

	ApInitMw(ap);

	while (term_flag == OFF) {
		ApStart(ap);
		/*	cnt :frame count						*/
		/*	cnt=0:interlace	/ cnt>0:non interlace	*/
		UsrInitSync(2);
		for (;;) {
			UsrSyncFrame();
			UsrBeginDraw();
			ret = ApExec(ap);
			UsrEndDraw();

			/* 終了するかどうかの確認					*/
			/* Checks whether Usr module is terminated	*/
			if (UsrIsTerminated() == TRUE) {
				term_flag = ON;
			}
			
			if (ret == FALSE || term_flag == ON) {
				break;
			}
		}
		ApStop(ap);
	}
	/*	アプリケーション終了処理	*/
	/*	Finalize application		*/
	ApFinishMw(ap);			/*	ミドルウェアの終了				*/
							/*	Finalize Middleware				*/
	UsrFinishSound();		/*	サウンドシステムの終了処理		*/
							/*	Finalize sound system			*/
	UsrFinishVideo();		/*	ビデオの終了処理				*/
							/*	Finalize Video system			*/
	UsrFinishSystem();		/*	システムの終了処理				*/
							/*	Finalize system					*/
	return 0;
}

/* end of file */
